|  | overview |  | wiki |  | api reference |  | download

- Main Page
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Functions Variables Typedefs Enumerations Enumerator
Classes | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes
gameplay::Transform Class Reference

`#include <Transform.h>`

Inheritance diagram for gameplay::Transform:

List of all members.

## Classes

class | Listener
struct | TransformListener

## Public Member Functions

| Transform ()
| Transform (const Vector3 &scale, const Quaternion &rotation, const Vector3 &translation)
| Transform (const Vector3 &scale, const Matrix &rotation, const Vector3 &translation)
| Transform (const Transform &copy)
virtual | ~Transform ()
const char * | getTypeName () const
const Matrix & | getMatrix () const
const Vector3 & | getScale () const
void | getScale (Vector3 *scale) const
float | getScaleX () const
float | getScaleY () const
float | getScaleZ () const
const Quaternion & | getRotation () const
void | getRotation (Quaternion *rotation) const
void | getRotation (Matrix *rotation) const
float | getRotation (Vector3 *axis) const
const Vector3 & | getTranslation () const
void | getTranslation (Vector3 *translation) const
float | getTranslationX () const
float | getTranslationY () const
float | getTranslationZ () const
Vector3 | getForwardVector () const
void | getForwardVector (Vector3 *dst) const
Vector3 | getBackVector () const
void | getBackVector (Vector3 *dst) const
Vector3 | getUpVector () const
void | getUpVector (Vector3 *dst) const
Vector3 | getDownVector () const
void | getDownVector (Vector3 *dst) const
Vector3 | getLeftVector () const
void | getLeftVector (Vector3 *dst) const
Vector3 | getRightVector () const
void | getRightVector (Vector3 *dst) const
void | rotate (float qx, float qy, float qz, float qw)
void | rotate (const Quaternion &rotation)
void | rotate (const Vector3 &axis, float angle)
void | rotate (const Matrix &rotation)
void | rotateX (float angle)
void | rotateY (float angle)
void | rotateZ (float angle)
void | scale (float scale)
void | scale (float sx, float sy, float sz)
void | scale (const Vector3 &scale)
void | scaleX (float sx)
void | scaleY (float sy)
void | scaleZ (float sz)
void | set (const Vector3 &scale, const Quaternion &rotation, const Vector3 &translation)
void | set (const Vector3 &scale, const Matrix &rotation, const Vector3 &translation)
void | set (const Vector3 &scale, const Vector3 &axis, float angle, const Vector3 &translation)
void | set (const Transform &transform)
void | setIdentity ()
void | setScale (float scale)
void | setScale (float sx, float sy, float sz)
void | setScale (const Vector3 &scale)
void | setScaleX (float sx)
void | setScaleY (float sy)
void | setScaleZ (float sz)
void | setRotation (float qx, float qy, float qz, float qw)
void | setRotation (const Quaternion &rotation)
void | setRotation (const Matrix &rotation)
void | setRotation (const Vector3 &axis, float angle)
void | setTranslation (const Vector3 &translation)
void | setTranslation (float tx, float ty, float tz)
void | setTranslationX (float tx)
void | setTranslationY (float ty)
void | setTranslationZ (float tz)
void | translate (float tx, float ty, float tz)
void | translate (const Vector3 &translation)
void | translateX (float tx)
void | translateY (float ty)
void | translateZ (float tz)
void | translateLeft (float amount)
void | translateUp (float amount)
void | translateForward (float amount)
void | translateSmooth (const Vector3 &target, float elapsedTime, float responseTime)
void | transformPoint (Vector3 *point)
void | transformPoint (const Vector3 &point, Vector3 *dst)
void | transformVector (Vector3 *vector)
void | transformVector (const Vector3 &transformVector, Vector3 *dst)
void | transformVector (float x, float y, float z, float w, Vector3 *dst)
virtual bool | isStatic () const
void | addListener (Transform::Listener *listener, long cookie=0)
void | removeListener (Transform::Listener *listener)
unsigned int | getAnimationPropertyComponentCount (int propertyId) const
void | getAnimationPropertyValue (int propertyId, AnimationValue *value)
void | setAnimationPropertyValue (int propertyId, AnimationValue *value, float blendWeight=1.0f)

## Static Public Member Functions

static void | suspendTransformChanged ()
static void | resumeTransformChanged ()
static bool | isTransformChangedSuspended ()

## Static Public Attributes

static const int | ANIMATE_SCALE_UNIT = 0
static const int | ANIMATE_SCALE = 1
static const int | ANIMATE_SCALE_X = 2
static const int | ANIMATE_SCALE_Y = 3
static const int | ANIMATE_SCALE_Z = 4
static const int | ANIMATE_ROTATE = 8
static const int | ANIMATE_TRANSLATE = 9
static const int | ANIMATE_TRANSLATE_X = 10
static const int | ANIMATE_TRANSLATE_Y = 11
static const int | ANIMATE_TRANSLATE_Z = 12
static const int | ANIMATE_ROTATE_TRANSLATE = 16
static const int | ANIMATE_SCALE_ROTATE_TRANSLATE = 17
static const int | ANIMATE_SCALE_TRANSLATE = 18
static const int | ANIMATE_SCALE_ROTATE = 19

## Protected Types

enum | MatrixDirtyBits { DIRTY_TRANSLATION = 0x01, DIRTY_SCALE = 0x02, DIRTY_ROTATION = 0x04, DIRTY_NOTIFY = 0x08 }

## Protected Member Functions

void | dirty (char matrixDirtyBits)
bool | isDirty (char matrixDirtyBits) const
virtual void | transformChanged ()
void | cloneInto (Transform *transform, NodeCloneContext &context) const

## Static Protected Member Functions

static void | suspendTransformChange (Transform *transform)

## Protected Attributes

Vector3 | _scale
Quaternion | _rotation
Vector3 | _translation
Matrix | _matrix
char | _matrixDirtyBits
std::list< TransformListener > * | _listeners

## Detailed Description

Defines a 3-dimensional transformation.

When using the scale, rotate, and translate methods, only the transform's corresponding scale, rotation, or translation component is updated (it is not as if the scale, rotate, or translate is applied to the transform's matrix).

Note: To construct a Transform from a transformation matrix stored as a Matrix, first decompose the Matrix into its separate translation, scale, and rotation components using matrix.decompose(Vector3, Quaternion, Vector3) and then pass those arguments to the appropriate constructor or set methods of Transform.

## Member Enumeration Documentation

enum gameplay::Transform::MatrixDirtyBits `[protected]`

Defines the matrix dirty bits for marking the translation, scale and rotation components of the Transform.

## Constructor & Destructor Documentation

gameplay::Transform::Transform | ( |  | ) |

Constructs the identity transform.

gameplay::Transform::Transform | ( | const Vector3 & | scale,
|  | const Quaternion & | rotation,
|  | const Vector3 & | translation
| ) |  |

Constructs a new transform from the specified values.

Parameters:

  scale | The scale vector.
  rotation | The rotation quaternion.
  translation | The translation vector.

gameplay::Transform::Transform | ( | const Vector3 & | scale,
|  | const Matrix & | rotation,
|  | const Vector3 & | translation
| ) |  |

Constructs a new transform from the specified values.

Parameters:

  scale | The scale vector.
  rotation | The rotation matrix.
  translation | The translation vector.

gameplay::Transform::Transform | ( | const Transform & | copy | ) |

Constructs a new transform from the given transform.

Parameters:

  copy | The transform to copy.

virtual gameplay::Transform::~Transform | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

void gameplay::Transform::addListener | ( | Transform::Listener * | listener,
|  | long | cookie = `0`
| ) |  |

Adds a transform listener.

Parameters:

  listener | The listener to add.
  cookie | An optional long value that is passed to the specified listener when it is called.

void gameplay::Transform::cloneInto | ( | Transform * | transform,
|  | NodeCloneContext & | context
| ) |  | const`[protected]`

Copies from data from this node into transform for the purpose of cloning.

Parameters:

  transform | The transform to copy into.
  context | The clone context.

void gameplay::Transform::dirty | ( | char | matrixDirtyBits | ) | `[protected]`

Marks this transform as dirty and fires transformChanged().

unsigned int gameplay::Transform::getAnimationPropertyComponentCount | ( | int | propertyId | ) | const`[virtual]`

See also:
  AnimationTarget::getAnimationPropertyComponentCount

Implements gameplay::AnimationTarget.

void gameplay::Transform::getAnimationPropertyValue | ( | int | propertyId,
|  | AnimationValue * | value
| ) |  | `[virtual]`

See also:
  AnimationTarget::getAnimationProperty

Implements gameplay::AnimationTarget.

Vector3 gameplay::Transform::getBackVector | ( |  | ) | const

Returns the back vector for this transform.

void gameplay::Transform::getBackVector | ( | Vector3 * | dst | ) | const

Returns the back vector for this Transform.

Parameters:

  dst | The vector to store the result in.

Vector3 gameplay::Transform::getDownVector | ( |  | ) | const

Returns the down vector for this transform.

void gameplay::Transform::getDownVector | ( | Vector3 * | dst | ) | const

Returns the down vector for this Transform.

Parameters:

  dst | The vector to store the result in.

Vector3 gameplay::Transform::getForwardVector | ( |  | ) | const

Returns the forward vector for this Transform.

void gameplay::Transform::getForwardVector | ( | Vector3 * | dst | ) | const

Returns the forward vector for this Transform.

Parameters:

  dst | The vector to store the result in.

Vector3 gameplay::Transform::getLeftVector | ( |  | ) | const

Returns the left vector for this Transform.

void gameplay::Transform::getLeftVector | ( | Vector3 * | dst | ) | const

Returns the left vector for this Transform.

Parameters:

  dst | The vector to store the result in.

const Matrix& gameplay::Transform::getMatrix | ( |  | ) | const

Gets the matrix corresponding to this transform.

The matrix returned from this method is mathematically equivalent to this transform only as long as this transform is not changed (i.e. by calling set(), setScale(), translate(), rotateX(), etc.). Once the transform has been changed, the user must call getMatrix() again to get the updated matrix. Also note that changing the matrix returned from this method does not change this transform.

Returns:
  The matrix of this transform.

Vector3 gameplay::Transform::getRightVector | ( |  | ) | const

Returns the right vector for this transform.

void gameplay::Transform::getRightVector | ( | Vector3 * | dst | ) | const

Returns the right vector for this Transform.

Parameters:

  dst | The vector to store the result in.

const Quaternion& gameplay::Transform::getRotation | ( |  | ) | const

Returns the rotation for this transform.

void gameplay::Transform::getRotation | ( | Quaternion * | rotation | ) | const

Gets the rotation component of this transform in the specified quaternion.

Parameters:

  rotation | The quaternion to store the rotation in.

void gameplay::Transform::getRotation | ( | Matrix * | rotation | ) | const

Gets the rotation component of this transform in the specified matrix.

Parameters:

  rotation | The matrix to store the rotation in.

float gameplay::Transform::getRotation | ( | Vector3 * | axis | ) | const

Gets the angle of rotation, and stores the axis of rotation of this transform in the specified Vector3.

Parameters:

  axis | The vector to store the axis of rotation.

Returns:
  The angle of rotation.

const Vector3& gameplay::Transform::getScale | ( |  | ) | const

Returns the scale for this transform.

void gameplay::Transform::getScale | ( | Vector3 * | scale | ) | const

Gets the scale component of this transform in the specified vector.

Parameters:

  scale | The vector to store the scale in.

float gameplay::Transform::getScaleX | ( |  | ) | const

Gets the scale factor along the x-axis of this transform.

Returns:
  The scale factor along the x-axis.

float gameplay::Transform::getScaleY | ( |  | ) | const

Gets the scale factor along the y-axis of this transform.

Returns:
  The scale factor along the y-axis.

float gameplay::Transform::getScaleZ | ( |  | ) | const

Gets the scale factor along the z-axis of this transform.

Returns:
  The scale factor along the z-axis.

const Vector3& gameplay::Transform::getTranslation | ( |  | ) | const

Returns the translation for this transform.

void gameplay::Transform::getTranslation | ( | Vector3 * | translation | ) | const

Gets the translation component of this transform in the specified vector.

Parameters:

  translation | The vector to store the translation in.

float gameplay::Transform::getTranslationX | ( |  | ) | const

Gets the translation factor along the x-axis of this transform.

Returns:
  The translation factor along the x-axis.

float gameplay::Transform::getTranslationY | ( |  | ) | const

Gets the translation factor along the y-axis of this transform.

Returns:
  The translation factor along the y-axis.

float gameplay::Transform::getTranslationZ | ( |  | ) | const

Gets the translation factor along the z-axis of this transform.

Returns:
  The translation factor along the z-axis.

const char* gameplay::Transform::getTypeName | ( |  | ) | const`[virtual]`

Extends ScriptTarget::getTypeName() to return the type name of this class.

Returns:
  The type name of this class: "Transform"

See also:
  ScriptTarget::getTypeName()

Implements gameplay::ScriptTarget.

Reimplemented in gameplay::Node.

Vector3 gameplay::Transform::getUpVector | ( |  | ) | const

Returns the up vector for this Transform.

void gameplay::Transform::getUpVector | ( | Vector3 * | dst | ) | const

Returns the up vector for this Transform.

Parameters:

  dst | The vector to store the result in.

bool gameplay::Transform::isDirty | ( | char | matrixDirtyBits | ) | const`[protected]`

Determines if the specified matrix dirty bit is set.

Parameters:

  matrixDirtyBits | the matrix dirty bit to check for dirtiness.

Returns:
  TRUE if the specified matrix dirty bit is set; FALSE if the specified matrix dirty bit is unset.

virtual bool gameplay::Transform::isStatic | ( |  | ) | const`[virtual]`

Returns whether or not this Transform object is static.

A static transform object cannot be transformed. This may be the case for special types of Transform objects, such as Nodes that have a static rigid body attached to them.

Returns:
  True if this Transform is static, false otherwise.

Reimplemented in gameplay::Node.

static bool gameplay::Transform::isTransformChangedSuspended | ( |  | ) | `[static]`

Gets whether all transform changed events are suspended.

Returns:
  TRUE if transform changed events are suspended; FALSE if transform changed events are not suspended.

void gameplay::Transform::removeListener | ( | Transform::Listener * | listener | ) |

Removes a transform listener.

Parameters:

  listener | The listener to remove.

static void gameplay::Transform::resumeTransformChanged | ( |  | ) | `[static]`

Globally resumes all transform changed events.

void gameplay::Transform::rotate | ( | float | qx,
|  | float | qy,
|  | float | qz,
|  | float | qw
| ) |  |

Rotates this transform's rotation component by the given rotation.

Parameters:

  qx | The quaternion x value.
  qy | The quaternion y value.
  qz | The quaternion z value.
  qw | The quaternion w value.

void gameplay::Transform::rotate | ( | const Quaternion & | rotation | ) |

Rotates this transform's rotation component by the given rotation.

Parameters:

  rotation | The rotation to rotate by (as a quaternion).

void gameplay::Transform::rotate | ( | const Vector3 & | axis,
|  | float | angle
| ) |  |

Rotates this transform's rotation component by the given rotation (defined as an axis angle rotation).

Parameters:

  axis | The axis to rotate about.
  angle | The axis to rotate about (in radians).

void gameplay::Transform::rotate | ( | const Matrix & | rotation | ) |

Rotates this transform's rotation component by the given rotation.

Parameters:

  rotation | The rotation to rotate by (as a matrix).

void gameplay::Transform::rotateX | ( | float | angle | ) |

Rotates this transform's rotation component by the given angle about the x-axis.

Parameters:

  angle | The angle to rotate by about the x-axis (in radians).

void gameplay::Transform::rotateY | ( | float | angle | ) |

Rotates this transform's rotation component by the given angle about the y-axis.

Parameters:

  angle | The angle to rotate by about the y-axis (in radians).

void gameplay::Transform::rotateZ | ( | float | angle | ) |

Rotates this transform's rotation component by the given angle about the z-axis.

Parameters:

  angle | The angle to rotate by about the z-axis (in radians).

void gameplay::Transform::scale | ( | float | scale | ) |

Scales this transform's scale component by the given factor along all axes.

Parameters:

  scale | The factor to scale by along all axis.

void gameplay::Transform::scale | ( | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Scales this transform's scale component by the given factors along each axis.

Parameters:

  sx | The factor to scale by in the x direction.
  sy | The factor to scale by in the y direction.
  sz | The factor to scale by in the z direction.

void gameplay::Transform::scale | ( | const Vector3 & | scale | ) |

Scales this transform's scale component by the given scale vector.

Parameters:

  scale | The vector to scale by.

void gameplay::Transform::scaleX | ( | float | sx | ) |

Scales this transform's scale component by the given scale factor along the x axis.

Parameters:

  sx | The scale factor along the x axis.

void gameplay::Transform::scaleY | ( | float | sy | ) |

Scales this transform's scale component by the given scale factor along the y axis.

Parameters:

  sy | The scale factor along the y axis.

void gameplay::Transform::scaleZ | ( | float | sz | ) |

Scales this transform's scale component by the given scale factor along the z axis.

Parameters:

  sz | The scale factor along the z axis.

void gameplay::Transform::set | ( | const Vector3 & | scale,
|  | const Quaternion & | rotation,
|  | const Vector3 & | translation
| ) |  |

Sets the transform to the specified values.

Parameters:

  scale | The scale vector.
  rotation | The rotation quaternion.
  translation | The translation vector.

void gameplay::Transform::set | ( | const Vector3 & | scale,
|  | const Matrix & | rotation,
|  | const Vector3 & | translation
| ) |  |

Sets the transform to the specified values.

Parameters:

  scale | The scale vector.
  rotation | The rotation matrix.
  translation | The translation vector.

void gameplay::Transform::set | ( | const Vector3 & | scale,
|  | const Vector3 & | axis,
|  | float | angle,
|  | const Vector3 & | translation
| ) |  |

Sets the transform to the specified values.

Parameters:

  scale | The scale vector.
  axis | The axis of rotation.
  angle | The angle of rotation (in radians).
  translation | The translation vector.

void gameplay::Transform::set | ( | const Transform & | transform | ) |

Sets this transform to the specified transform.

Parameters:

  transform | The transform to set this transform to.

void gameplay::Transform::setAnimationPropertyValue | ( | int | propertyId,
|  | AnimationValue * | value,
|  | float | blendWeight = `1.0f`
| ) |  | `[virtual]`

See also:
  AnimationTarget::setAnimationProperty

Implements gameplay::AnimationTarget.

void gameplay::Transform::setIdentity | ( |  | ) |

Sets this transform to the identity transform.

void gameplay::Transform::setRotation | ( | float | qx,
|  | float | qy,
|  | float | qz,
|  | float | qw
| ) |  |

Sets the rotation component for this transform to the specified values.

Parameters:

  qx | The quaternion x value.
  qy | The quaternion y value.
  qz | The quaternion z value.
  qw | The quaternion w value.

void gameplay::Transform::setRotation | ( | const Quaternion & | rotation | ) |

Sets the rotation component for this transform to the specified values.

Parameters:

  rotation | The rotation as a quaternion.

void gameplay::Transform::setRotation | ( | const Matrix & | rotation | ) |

Sets the rotation component for this transform to the specified values.

Parameters:

  rotation | The rotation as a matrix.

void gameplay::Transform::setRotation | ( | const Vector3 & | axis,
|  | float | angle
| ) |  |

Sets the rotation component for this transform to the rotation from the specified axis and angle.

Parameters:

  axis | The axis of rotation.
  angle | The angle of rotation (in radians).

void gameplay::Transform::setScale | ( | float | scale | ) |

Sets the scale factor along all axes for this transform to the specified value.

Parameters:

  scale | The scale factor along all axes.

void gameplay::Transform::setScale | ( | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

Sets the scale component of this transform to the specified values.

Parameters:

  sx | The scale factor along the x axis.
  sy | The scale factor along the y axis.
  sz | The scale factor along the z axis.

void gameplay::Transform::setScale | ( | const Vector3 & | scale | ) |

Sets the scale component of this transform to the specified scale vector.

Parameters:

  scale | The scale vector.

void gameplay::Transform::setScaleX | ( | float | sx | ) |

Sets the scale factor along the x-axis for this transform to the specified value.

Parameters:

  sx | The scale factor along the x-axis.

void gameplay::Transform::setScaleY | ( | float | sy | ) |

Sets the scale factor along the y-axis for this transform to the specified value.

Parameters:

  sy | The scale factor along the y-axis.

void gameplay::Transform::setScaleZ | ( | float | sz | ) |

Sets the scale factor along the z-axis for this transform to the specified value.

Parameters:

  sz | The scale factor along the z-axis.

void gameplay::Transform::setTranslation | ( | const Vector3 & | translation | ) |

Sets the translation component for this transform to the specified translation vector.

Parameters:

  translation | The translation vector.

void gameplay::Transform::setTranslation | ( | float | tx,
|  | float | ty,
|  | float | tz
| ) |  |

Sets the translation component for this transform to the specified values.

Parameters:

  tx | The translation amount in the x direction.
  ty | The translation amount in the y direction.
  tz | The translation amount in the z direction.

void gameplay::Transform::setTranslationX | ( | float | tx | ) |

Sets the translation factor along the x-axis for this transform to the specified value.

Parameters:

  tx | The translation factor along the x-axis.

void gameplay::Transform::setTranslationY | ( | float | ty | ) |

Sets the translation factor along the y-axis for this transform to the specified value.

Parameters:

  ty | The translation factor along the y-axis.

void gameplay::Transform::setTranslationZ | ( | float | tz | ) |

Sets the translation factor along the z-axis for this transform to the specified value.

Parameters:

  tz | The translation factor along the z-axis.

static void gameplay::Transform::suspendTransformChange | ( | Transform * | transform | ) | `[static, protected]`

Adds the specified transform to the list of transforms waiting to be notified of a change. Sets the DIRTY_NOTIFY bit on the transform.

static void gameplay::Transform::suspendTransformChanged | ( |  | ) | `[static]`

Globally suspends all transform changed events.

virtual void gameplay::Transform::transformChanged | ( |  | ) | `[protected, virtual]`

Called when the transform changes.

Reimplemented in gameplay::Node, and gameplay::Joint.

void gameplay::Transform::transformPoint | ( | Vector3 * | point | ) |

Transforms the specified point and stores the result in the original point.

Parameters:

  point | The point to transform.

void gameplay::Transform::transformPoint | ( | const Vector3 & | point,
|  | Vector3 * | dst
| ) |  |

Transforms the specified point and stores the result in the specified destination point.

Parameters:

  point | The point to transform.
  dst | The point to store the result in.

void gameplay::Transform::transformVector | ( | Vector3 * | vector | ) |

Transforms the specified vector and stores the result in the original vector.

Parameters:

  vector | The vector to transform.

void gameplay::Transform::transformVector | ( | const Vector3 & | transformVector,
|  | Vector3 * | dst
| ) |  |

Transforms the specified vector and stores the result in the original vector.

Parameters:

  transformVector | The vector to transform.
  dst | The vector to store the result in.

void gameplay::Transform::transformVector | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | w,
|  | Vector3 * | dst
| ) |  |

Transforms the specified vector and stores the result in the specified destination vector.

Parameters:

  x | The x factor to transform.
  y | The y factor to transform.
  z | The z factor to transform.
  w | The w factor to transform.
  dst | The vector to store the result in.

void gameplay::Transform::translate | ( | float | tx,
|  | float | ty,
|  | float | tz
| ) |  |

Translates this transform's translation component by the given values along each axis.

Parameters:

  tx | The amount to translate along the x axis.
  ty | The amount to translate along the y axis.
  tz | The amount to translate along the z axis.

void gameplay::Transform::translate | ( | const Vector3 & | translation | ) |

Translates this transform's translation component by the given translation vector.

Parameters:

  translation | The amount to translate.

void gameplay::Transform::translateForward | ( | float | amount | ) |

Translates the camera forward by the specified amount in the z-axis.

Parameters:

  amount | The amount to translate.

void gameplay::Transform::translateLeft | ( | float | amount | ) |

Translates the camera left by the specified amount in the x-axis.

Parameters:

  amount | The amount to translate.

void gameplay::Transform::translateSmooth | ( | const Vector3 & | target,
|  | float | elapsedTime,
|  | float | responseTime
| ) |  |

Translates the camera towards the given target using a smoothing function. The given response time determines the amount of smoothing (lag). A longer response time yields a smoother result and more lag. To force the camera to follow the target closely, provide a response time that is very small relative to the given elapsed time.

Parameters:

  target | target value.
  elapsedTime | elapsed time between calls.
  responseTime | response time (in the same units as elapsedTime).

void gameplay::Transform::translateUp | ( | float | amount | ) |

Translates the camera up by the specified amount in the y-axis.

Parameters:

  amount | The amount to translate.

void gameplay::Transform::translateX | ( | float | tx | ) |

Translates this transform's translation component by the given value along the x axis.

Parameters:

  tx | The amount to translate along the x axis.

void gameplay::Transform::translateY | ( | float | ty | ) |

Translates this transform's translation component by the given value along the y axis.

Parameters:

  ty | The amount to translate along the y axis.

void gameplay::Transform::translateZ | ( | float | tz | ) |

Translates this transform's translation component by the given value along the z axis.

Parameters:

  tz | The amount to translate along the z axis.

## Member Data Documentation

std::list<TransformListener>* gameplay::Transform::_listeners `[protected]`

List of TransformListener's on the Transform.

Matrix gameplay::Transform::_matrix `[mutable, protected]`

The Matrix representation of the Transform.

char gameplay::Transform::_matrixDirtyBits `[mutable, protected]`

Matrix dirty bits flag.

Quaternion gameplay::Transform::_rotation `[protected]`

The rotation component of the Transform.

Vector3 gameplay::Transform::_scale `[protected]`

The scale component of the Transform.

Vector3 gameplay::Transform::_translation `[protected]`

The translation component of the Transform.

const int gameplay::Transform::ANIMATE_ROTATE = 8`[static]`

Rotation animation property. Data=qx,qy,qz,qw (as quaternion).

const int gameplay::Transform::ANIMATE_ROTATE_TRANSLATE = 16`[static]`

Rotation + Translation animation property (Rigid Body). Data=qx,qy,qz,qw,tx,ty,tz

const int gameplay::Transform::ANIMATE_SCALE = 1`[static]`

Scale animation property. Data=sx,sy,sz

const int gameplay::Transform::ANIMATE_SCALE_ROTATE = 19`[static]`

Scale + Rotation animation property. Data=sx,sy,sz,qx,qy,qz,qw

const int gameplay::Transform::ANIMATE_SCALE_ROTATE_TRANSLATE = 17`[static]`

Scale, Rotation + Translation animation property. Data=sx,sy,sz,qx,qy,qz,qw,tx,ty,tz

const int gameplay::Transform::ANIMATE_SCALE_TRANSLATE = 18`[static]`

Scale + Translation animation property. Data=sx,sy,sz,tx,ty,tz

const int gameplay::Transform::ANIMATE_SCALE_UNIT = 0`[static]`

Scale animation property. Data=scale

const int gameplay::Transform::ANIMATE_SCALE_X = 2`[static]`

Scale x animation property. Data=sx

const int gameplay::Transform::ANIMATE_SCALE_Y = 3`[static]`

Scale y animation property. Data=sy

const int gameplay::Transform::ANIMATE_SCALE_Z = 4`[static]`

Scale z animation property. Data=sz

const int gameplay::Transform::ANIMATE_TRANSLATE = 9`[static]`

Translate animation property. Data=tx,ty,tz

const int gameplay::Transform::ANIMATE_TRANSLATE_X = 10`[static]`

Translate x animation property. Data=tx

const int gameplay::Transform::ANIMATE_TRANSLATE_Y = 11`[static]`

Translate y animation property. Data=ty

const int gameplay::Transform::ANIMATE_TRANSLATE_Z = 12`[static]`

Translate z animation property. Data=tz

All Classes Functions Variables Typedefs Enumerations Enumerator